Package org.apache.velocity.runtime

# Class RuntimeSingleton

java.lang.Object
org.apache.velocity.runtime.RuntimeSingleton

All Implemented Interfaces:
  `DeprecatedRuntimeConstants`, `RuntimeConstants`

public class RuntimeSingleton extends Object implements RuntimeConstants

This is the Runtime system for Velocity. It is the single access point for all functionality in Velocity. It adheres to the mediator pattern and is the only structure that developers need to be familiar with in order to get Velocity to perform.

The Runtime will also cooperate with external systems, which can make all needed setProperty() calls before calling init().

     -----------------------------------------------------------------------
     N O T E S  O N  R U N T I M E  I N I T I A L I Z A T I O N
     -----------------------------------------------------------------------
     RuntimeSingleton.init()

     If Runtime.init() is called by itself the Runtime will
     initialize with a set of default values.
     -----------------------------------------------------------------------
     RuntimeSingleton.init(String/Properties)

     In this case the default velocity properties are laid down
     first to provide a solid base, then any properties provided
     in the given properties object will override the corresponding
     default property.
     -----------------------------------------------------------------------

Version:
  $Id$
Author:
  Jason van Zyl, Jeff Bowden, Geir Magusson Jr., Daniel Rall
See Also:
  - `RuntimeInstance`

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.apache.velocity.runtime.RuntimeConstants

`RuntimeConstants.SpaceGobbling`

## Field Summary

### Fields inherited from interface org.apache.velocity.runtime.DeprecatedRuntimeConstants

`OLD_CHECK_EMPTY_OBJECTS, OLD_CONTEXT_AUTOREFERENCE_KEY, OLD_CONVERSION_HANDLER_CLASS, OLD_CUSTOM_DIRECTIVES, OLD_DEFINE_DIRECTIVE_MAXDEPTH, OLD_DS_RESOURCE_LOADER_DATASOURCE, OLD_DS_RESOURCE_LOADER_KEY_COLUMN, OLD_DS_RESOURCE_LOADER_TEMPLATE_COLUMN, OLD_DS_RESOURCE_LOADER_TIMESTAMP_COLUMN, OLD_ERRORMSG_END, OLD_ERRORMSG_START, OLD_EVENTHANDLER_INCLUDE, OLD_EVENTHANDLER_INVALIDREFERENCES, OLD_EVENTHANDLER_METHODEXCEPTION, OLD_EVENTHANDLER_REFERENCEINSERTION, OLD_FILE_RESOURCE_LOADER_CACHE, OLD_FILE_RESOURCE_LOADER_PATH, OLD_INPUT_ENCODING, OLD_INTERPOLATE_STRINGLITERALS, OLD_MAX_NUMBER_LOOPS, OLD_PARSE_DIRECTIVE_MAXDEPTH, OLD_RESOURCE_LOADER_CHECK_INTERVAL, OLD_RESOURCE_LOADERS, OLD_RESOURCE_MANAGER_DEFAULTCACHE_SIZE, OLD_RESOURCE_MANAGER_LOGWHENFOUND, OLD_RUNTIME_LOG_REFERENCE_LOG_INVALID, OLD_RUNTIME_REFERENCES_STRICT, OLD_RUNTIME_REFERENCES_STRICT_ESCAPE, OLD_SKIP_INVALID_ITERATOR, OLD_SPACE_GOBBLING, OLD_STRICT_MATH, OLD_UBERSPECT_CLASSNAME, OLD_VM_BODY_REFERENCE, OLD_VM_ENABLE_BC_MODE, OLD_VM_LIBRARY, OLD_VM_LIBRARY_DEFAULT, OLD_VM_MAX_DEPTH, OLD_VM_PERM_ALLOW_INLINE, OLD_VM_PERM_ALLOW_INLINE_REPLACE_GLOBAL, OLD_VM_PERM_INLINE_LOCAL`

### Fields inherited from interface org.apache.velocity.runtime.RuntimeConstants

`CHECK_EMPTY_OBJECTS, CONTEXT_AUTOREFERENCE_KEY, CONTEXT_SCOPE_CONTROL, CONVERSION_HANDLER_CLASS, CONVERSION_HANDLER_INSTANCE, CUSTOM_DIRECTIVES, DEFAULT_PARSER_CLASS, DEFAULT_RUNTIME_DIRECTIVES, DEFAULT_RUNTIME_LOG_NAME, DEFAULT_RUNTIME_PROPERTIES, DEFINE_DIRECTIVE_MAXDEPTH, DS_RESOURCE_LOADER_DATASOURCE, DS_RESOURCE_LOADER_DATASOURCE_URL, DS_RESOURCE_LOADER_KEY_COLUMN, DS_RESOURCE_LOADER_STMT_POOL_MAX_SIZE, DS_RESOURCE_LOADER_TABLE, DS_RESOURCE_LOADER_TEMPLATE_COLUMN, DS_RESOURCE_LOADER_TIMESTAMP_COLUMN, ENCODING_DEFAULT, ERRORMSG_END, ERRORMSG_START, EVENTHANDLER_INCLUDE, EVENTHANDLER_INVALIDREFERENCES, EVENTHANDLER_INVALIDREFERENCES_NULL, EVENTHANDLER_INVALIDREFERENCES_QUIET, EVENTHANDLER_INVALIDREFERENCES_TESTED, EVENTHANDLER_METHODEXCEPTION, EVENTHANDLER_REFERENCEINSERTION, FILE_RESOURCE_LOADER_CACHE, FILE_RESOURCE_LOADER_PATH, IMMUTABLE_RANGES, INPUT_ENCODING, INTERPOLATE_STRINGLITERALS, INTROSPECTOR_RESTRICT_CLASSES, INTROSPECTOR_RESTRICT_PACKAGES, MAX_NUMBER_LOOPS, NUMBER_OF_PARSERS, PARSE_DIRECTIVE_MAXDEPTH, PARSER_CLASS, PARSER_HYPHEN_ALLOWED, PARSER_POOL_CLASS, PARSER_POOL_SIZE, PROVIDE_SCOPE_CONTROL, RESOURCE_LOADER, RESOURCE_LOADER_CACHE, RESOURCE_LOADER_CHECK_INTERVAL, RESOURCE_LOADER_CLASS, RESOURCE_LOADER_IDENTIFIER, RESOURCE_LOADER_INSTANCE, RESOURCE_LOADER_PATHS, RESOURCE_LOADERS, RESOURCE_MANAGER_CACHE_CLASS, RESOURCE_MANAGER_CLASS, RESOURCE_MANAGER_DEFAULTCACHE_SIZE, RESOURCE_MANAGER_INSTANCE, RESOURCE_MANAGER_LOGWHENFOUND, RUNTIME_LOG_INSTANCE, RUNTIME_LOG_METHOD_CALL_LOG_INVALID, RUNTIME_LOG_NAME, RUNTIME_LOG_REFERENCE_LOG_INVALID, RUNTIME_LOG_TRACK_LOCATION, RUNTIME_REFERENCES_STRICT, RUNTIME_REFERENCES_STRICT_ESCAPE, RUNTIME_STRING_INTERNING, SKIP_INVALID_ITERATOR, SPACE_GOBBLING, STRICT_MATH, UBERSPECT_CLASSNAME, VM_ARGUMENTS_STRICT, VM_BODY_REFERENCE, VM_ENABLE_BC_MODE, VM_LIBRARY, VM_LIBRARY_AUTORELOAD, VM_LIBRARY_DEFAULT, VM_MAX_DEPTH, VM_MESSAGES_ON, VM_PERM_ALLOW_INLINE, VM_PERM_ALLOW_INLINE_REPLACE_GLOBAL, VM_PERM_INLINE_LOCAL`

## Constructor Summary

Constructors
Constructor
Description
`RuntimeSingleton()`

## Method Summary

Modifier and Type
Method
Description
`static void`
`addProperty(String key, Object value)`
Add a property to the configuration.
`static boolean`
`addVelocimacro(String name, Node macro, List<Macro.MacroArg> macroArgs, Template definingTemplate)`
Adds a new Velocimacro.
`static void`
`clearProperty(String key)`
Clear the values pertaining to a particular property.
`static Object`
`getApplicationAttribute(Object key)`
Gets the application attribute for the given key
`static boolean`
`getBoolean(String key, boolean def)`
Boolean property accessor method to hide the configuration implementation.
`static ExtProperties`
`getConfiguration()`
Return the velocity runtime configuration object.
`static ContentResource`
`getContent(String name)`
Returns a static content resource from the resource manager.
`static ContentResource`
`getContent(String name, String encoding)`
Returns a static content resource from the resource manager.
`EventCartridge`
`getEventCartridge()`
Returns the event handlers for the application.
`static int`
`getInt(String key)`
Int property accessor method to hide the configuration implementation.
`static int`
`getInt(String key, int defaultValue)`
Int property accessor method to hide the configuration implementation.
`static String`
`getLoaderNameForResource(String resourceName)`
Determines is a template exists, and returns name of the loader that provides it.
`static org.slf4j.Logger`
`getLog()`
Returns the configured logger.
`static Object`
`getProperty(String key)`
Allows an external caller to get a property.
`static RuntimeServices`
`getRuntimeServices()`
Returns the RuntimeServices Instance used by this wrapper.
`static String`
`getString(String key)`
String property accessor method to hide the configuration implementation
`static String`
`getString(String key, String defaultValue)`
String property accessor method with default to hide the configuration implementation.
`static Template`
`getTemplate(String name)`
Returns a `Template` from the resource manager.
`static Template`
`getTemplate(String name, String encoding)`
Returns a `Template` from the resource manager
`static Uberspect`
`getUberspect()`
Returns the Uberspect object for this Instance.
`static Directive`
`getVelocimacro(String vmName, Template renderingTemplate, Template template)`
Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.
`static void`
`init()`
This is the primary initialization method in the Velocity Runtime.
`static void`
`init(String configurationFile)`
Initialize the Velocity Runtime with the name of a properties file.
`static void`
`init(Properties p)`
Initialize the Velocity Runtime with a Properties object.
`static boolean`
`isInitialized()`
Returns true if the RuntimeInstance has been successfully initialized.
`static boolean`
`isVelocimacro(String vmName, Template template)`
Checks to see if a VM exists
`static void`
`loadDirective(String directiveClass)`
Instantiates and loads the directive with some basic checks.
`static SimpleNode`
`parse(Reader reader, Template template)`
Parse the input and return the root of AST node structure.
`static void`
`removeDirective(String name)`
Remove a directive.
`static void`
`reset()`
Resets the instance, so Velocity can be re-initialized again.
`static void`
`setConfiguration(ExtProperties configuration)`
Directly set the ExtProperties configuration object
`static void`
`setProperties(String propsFilename)`
Set an entire configuration at once from a named properties file
`static void`
`setProperties(Properties configuration)`
Allow an external system to set a Properties object to use.
`static void`
`setProperty(String key, Object value)`
Allows an external system to set a property in the Velocity Runtime.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### RuntimeSingleton

public RuntimeSingleton()

## Method Details

### init

public static void init()
This is the primary initialization method in the Velocity Runtime. The systems that are setup/initialized here are as follows:

- Logging System
- ResourceManager
- Event Handlers
- Parser Pool
- Global Cache
- Static Content Include System
- Velocimacro System

See Also:
  - `RuntimeInstance.init()`

### reset

public static void reset()
Resets the instance, so Velocity can be re-initialized again.

Since:
  2.0.0

### isInitialized

public static boolean isInitialized()
Returns true if the RuntimeInstance has been successfully initialized.

Returns:
  True if the RuntimeInstance has been successfully initialized.
Since:
  1.5
See Also:
  - `RuntimeInstance.isInitialized()`

### getRuntimeServices

public static RuntimeServices getRuntimeServices()
Returns the RuntimeServices Instance used by this wrapper.

Returns:
  The RuntimeServices Instance used by this wrapper.

### setProperty

public static void setProperty(String key, Object value)
Allows an external system to set a property in the Velocity Runtime.

Parameters:
  `key` - property key
  `value` - property value
See Also:
  - `RuntimeInstance.setProperty(String, Object)`

### setProperties

public static void setProperties(Properties configuration)
Allow an external system to set a Properties object to use.

Parameters:
  `configuration` -
See Also:
  - `RuntimeInstance.setProperties(Properties)`

### setProperties

public static void setProperties(String propsFilename)
Set an entire configuration at once from a named properties file

Parameters:
  `propsFilename` - properties filename
Since:
  2.1

### addProperty

public static void addProperty(String key, Object value)
Add a property to the configuration. If it already exists then the value stated here will be added to the configuration entry. For example, if resource.loader = file is already present in the configuration and you addProperty("resource.loader", "classpath") Then you will end up with a Vector like the following: ["file", "classpath"]

Parameters:
  `key` -
  `value` -
See Also:
  - `RuntimeInstance.addProperty(String, Object)`

### clearProperty

public static void clearProperty(String key)
Clear the values pertaining to a particular property.

Parameters:
  `key` - of property to clear
See Also:
  - `RuntimeInstance.clearProperty(String)`

### getProperty

public static Object getProperty(String key)
Allows an external caller to get a property. The calling routine is required to know the type, as this routine will return an Object, as that is what properties can be.

Parameters:
  `key` - property to return
Returns:
  Value of the property or null if it does not exist.
See Also:
  - `RuntimeInstance.getProperty(String)`

### init

public static void init(Properties p)
Initialize the Velocity Runtime with a Properties object.

Parameters:
  `p` -
See Also:
  - `RuntimeInstance.init(Properties)`

### init

public static void init(String configurationFile)
Initialize the Velocity Runtime with the name of a properties file.

Parameters:
  `configurationFile` -
See Also:
  - `RuntimeInstance.init(String)`

### parse

public static SimpleNode parse(Reader reader, Template template) throws ParseException
Parse the input and return the root of AST node structure.
In the event that it runs out of parsers in the pool, it will create and let them be GC'd dynamically, logging that it has to do that. This is considered an exceptional condition. It is expected that the user will set the PARSER_POOL_SIZE property appropriately for their application. We will revisit this.

Parameters:
  `reader` - Reader retrieved by a resource loader
  `template` - Template being parsed
Returns:
  A root node representing the template as an AST tree.
Throws:
  `ParseException` - When the template could not be parsed.
See Also:
  - `RuntimeInstance.parse(Reader, Template)`

### getTemplate

public static Template getTemplate(String name) throws ResourceNotFoundException, ParseErrorException
Returns a `Template` from the resource manager. This method assumes that the character encoding of the template is set by the `resource.default_encoding` property. The default is UTF-8.

Parameters:
  `name` - The file name of the desired template.
Returns:
  The template.
Throws:
  `ResourceNotFoundException` - if template not found from any available source.
  `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
See Also:
  - `RuntimeInstance.getTemplate(String)`

### getTemplate

public static Template getTemplate(String name, String encoding) throws ResourceNotFoundException, ParseErrorException
Returns a `Template` from the resource manager

Parameters:
  `name` - The name of the desired template.
  `encoding` - Character encoding of the template
Returns:
  The template.
Throws:
  `ResourceNotFoundException` - if template not found from any available source.
  `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
See Also:
  - `RuntimeInstance.getTemplate(String, String)`

### getContent

public static ContentResource getContent(String name) throws ResourceNotFoundException, ParseErrorException
Returns a static content resource from the resource manager. Uses the current value if INPUT_ENCODING as the character encoding.

Parameters:
  `name` - Name of content resource to get
Returns:
  parsed ContentResource object ready for use
Throws:
  `ResourceNotFoundException` - if template not found from any available source.
  `ParseErrorException` - When the template could not be parsed.
See Also:
  - `RuntimeInstance.getContent(String)`

### getContent

public static ContentResource getContent(String name, String encoding) throws ResourceNotFoundException, ParseErrorException
Returns a static content resource from the resource manager.

Parameters:
  `name` - Name of content resource to get
  `encoding` - Character encoding to use
Returns:
  parsed ContentResource object ready for use
Throws:
  `ResourceNotFoundException` - if template not found from any available source.
  `ParseErrorException` - When the template could not be parsed.
See Also:
  - `RuntimeInstance.getContent(String, String)`

### getLoaderNameForResource

public static String getLoaderNameForResource(String resourceName)
Determines is a template exists, and returns name of the loader that provides it. This is a slightly less hokey way to support the Velocity.templateExists() utility method, which was broken when per-template encoding was introduced. We can revisit this.

Parameters:
  `resourceName` - Name of template or content resource
Returns:
  class name of loader than can provide it
See Also:
  - `RuntimeInstance.getLoaderNameForResource(String)`

### getLog

public static org.slf4j.Logger getLog()
Returns the configured logger.

Returns:
  A Logger instance
Since:
  1.5
See Also:
  - `RuntimeInstance.getLog()`

### getString

public static String getString(String key, String defaultValue)
String property accessor method with default to hide the configuration implementation.

Parameters:
  `key` - property key
  `defaultValue` - default value to return if key not found in resource manager.
Returns:
  value of key or default
See Also:
  - `RuntimeInstance.getString(String, String)`

### getVelocimacro

public static Directive getVelocimacro(String vmName, Template renderingTemplate, Template template)
Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.

Parameters:
  `vmName` - Name of velocimacro requested
  `renderingTemplate` - Template we are currently rendering. This information is needed when VM_PERM_ALLOW_INLINE_REPLACE_GLOBAL setting is true and template contains a macro with the same name as the global macro library.
  `template` - current template
Returns:
  VelocimacroProxy

### addVelocimacro

public static boolean addVelocimacro(String name, Node macro, List<Macro.MacroArg> macroArgs, Template definingTemplate)
Adds a new Velocimacro. Usually called by Macro only while parsing.

Parameters:
  `name` - Name of a new velocimacro.
  `macro` - root AST node of the parsed macro
  `macroArgs` - Array of macro arguments, containing the #macro() arguments and default values. the 0th is the name.
  `definingTemplate` - Template containing the definition of the macro.
Returns:
  true for success

### isVelocimacro

public static boolean isVelocimacro(String vmName, Template template)
Checks to see if a VM exists

Parameters:
  `vmName` - Name of the Velocimacro.
  `template` - Template on which to look for the Macro.
Returns:
  True if VM by that name exists, false if not

### getString

public static String getString(String key)
String property accessor method to hide the configuration implementation

Parameters:
  `key` - property key
Returns:
  value of key or null
See Also:
  - `RuntimeInstance.getString(String)`

### getInt

public static int getInt(String key)
Int property accessor method to hide the configuration implementation.

Parameters:
  `key` - Property key
Returns:
  value
See Also:
  - `RuntimeInstance.getInt(String)`

### getInt

public static int getInt(String key, int defaultValue)
Int property accessor method to hide the configuration implementation.

Parameters:
  `key` - property key
  `defaultValue` - The default value.
Returns:
  value
See Also:
  - `RuntimeInstance.getInt(String, int)`

### getBoolean

public static boolean getBoolean(String key, boolean def)
Boolean property accessor method to hide the configuration implementation.

Parameters:
  `key` - property key
  `def` - The default value if property not found.
Returns:
  value of key or default value
See Also:
  - `RuntimeInstance.getBoolean(String, boolean)`

### setConfiguration

public static void setConfiguration(ExtProperties configuration)
Directly set the ExtProperties configuration object

Parameters:
  `configuration` -
See Also:
  - `RuntimeInstance.setConfiguration(ExtProperties)`

### getConfiguration

public static ExtProperties getConfiguration()
Return the velocity runtime configuration object.

Returns:
  ExtProperties configuration object which houses the velocity runtime properties.
See Also:
  - `RuntimeInstance.getConfiguration()`

### getEventCartridge

public EventCartridge getEventCartridge()
Returns the event handlers for the application.

Returns:
  The event handlers for the application.
Since:
  1.5
See Also:
  - `RuntimeInstance.getApplicationEventCartridge()`

### getApplicationAttribute

public static Object getApplicationAttribute(Object key)
Gets the application attribute for the given key

Parameters:
  `key` -
Returns:
  The application attribute for the given key.
See Also:
  - `RuntimeServices.getApplicationAttribute(Object)`
  - `RuntimeInstance.getApplicationAttribute(Object)`

### getUberspect

public static Uberspect getUberspect()
Returns the Uberspect object for this Instance.

Returns:
  The Uberspect object for this Instance.
See Also:
  - `RuntimeServices.getUberspect()`
  - `RuntimeInstance.getUberspect()`

### removeDirective

public static void removeDirective(String name)
Remove a directive.

Parameters:
  `name` - name of the directive.

### loadDirective

public static void loadDirective(String directiveClass)
Instantiates and loads the directive with some basic checks.

Parameters:
  `directiveClass` - classname of directive to load